<template>
  <div
    class="kit locations select"
    :class="[variation]">
    <multiselect
      :value="city"
      class="no-checkbox"
      :options="locations || []"
      :allow-empty="false"
      :searchable="true"
      :show-labels="true"
      :clear-on-select="true"
      :loading="loading"
      :placeholder="placeholder ? placeholder : 'Укажите название вашего города'"
      @select="onSelect"
      track-by="id"
      label="name"
      typre="search">
      <template
        slot="singleLabel"
        slot-scope="{ option }">
        {{ option.name }}{{ option.parent ? `. ${option.parent.name}` : '' }}
      </template>
      <template
        slot="option"
        slot-scope="{ option }">
        {{ option.name }}{{ option.parent ? `. ${option.parent.name}` : '' }}
      </template>
      <template slot="noResult">
        Укажите название вашего города, а после выберите его в списке.
      </template>
    </multiselect>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';

import { GeoLevel } from '~/backend/api-bundle/graphql/types';

export default {
  name: 'CitySearch',
  components: {
    multiselect: Multiselect,
  },
  props: {
    value: {
      type: Object,
      default: null,
    },
    placeholder: {
      type: String,
      default: '',
    },
    variation: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      locations: [],
      loading: true,
    };
  },
  computed: {
    city() {
      return (this.value && this.value.name && this.value.id) && this.value;
    },
  },
  async mounted() {
    this.locations = await this.$axios.$get('/_main/geo/list', { params: { level: GeoLevel.City } })
      .then(response => response.data)
      .catch(e => console.error(e));
    this.loading = false;
  },
  methods: {
    onSelect(value) {
      this.$emit('input', value);
    },
  },
};
</script>
